unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  apOpenSplit   = function(file1:PChar ): Longint ; stdcall	;
  apCreateMerge = function(file1:PChar ): Longint	; stdcall	;
  apClose       = procedure(id:Longint )          ; stdcall ;
  apSetFunction = function(id:Longint;func_code:Longint;
                           para1:Longint;para2:Longint;para3:PChar ;para4:PChar ): Longint ; stdcall ;
  apGetFunction = function(id:Longint;func_code:Longint;
                           para1:Longint;para2:Longint;para3:PChar ;para4:PChar ): Longint ; stdcall ;
  apAddInfo     = function(id:Longint;
                           Title:PChar;Subject:PChar;Author:PChar;Keywords:PChar;Creator:PChar ): Longint	; stdcall	;

const

  {define for apSetFunction}
  ap_Set_Split : Longint =	170;
  ap_Set_Merge : Longint =	175;
  ap_Set_Log   : Longint =	172;

  {define for apGetFunction}
  ap_Get_PageCount : Longint = 206;

var

  Form1: TForm1;
  g_hapW : HMODULE	;

  fnOpenSplit   : apOpenSplit ;
  fnCreateMerge : apCreateMerge ;
  fnClose       : apClose ;
  fnSetFunction : apSetFunction ;
  fnGetFunction : apGetFunction ;
  fnAddInfo     : apAddInfo ;


implementation

{$R *.dfm}


//****************************************************************************

function FreeapWDll() : Boolean;
begin
	if(g_hapW = 0) then begin
		FreeapWDll:=False;
    Exit;
  end;
	FreeLibrary(g_hapW);
	g_hapW:=0;
  Result:=True;
end;
//****************************************************************************

function  LoadapWDll :Boolean ;
var
  path:PAnsiChar ;
  proc :FARPROC ;
label
  Failer;

begin
  path := 'pdfspme.dll';
  g_hapW :=LoadLibrary(path);
	if(g_hapW=0) then
		goto Failer;

	proc:=GetProcAddress(g_hapW,'apOpenSplit');
	if(proc=nil)then
		goto Failer;
  fnOpenSplit:=proc ;

	proc:=GetProcAddress(g_hapW,'apCreateMerge');
	if(proc=nil)then
		goto Failer;
  fnCreateMerge:=proc ;

  proc:=GetProcAddress(g_hapW,'apClose');
	if(proc=nil)then
		goto Failer;
  fnClose:=proc ;

  proc:=GetProcAddress(g_hapW,'apSetFunction');
	if(proc=nil)then
		goto Failer;
  fnSetFunction:=proc ;
  proc:=GetProcAddress(g_hapW,'apGetFunction');
	if(proc=nil)then
		goto Failer;
  fnGetFunction:=proc ;

  proc:=GetProcAddress(g_hapW,'apAddInfo');
	if(proc=nil)then
		goto Failer;
  fnAddInfo:=proc ;

  Result:=True;
  Exit;
  Failer:
  FreeapWDll();
  Result:=False;
end;

//****************************************************************************
procedure TForm1.Button1Click(Sender: TObject);
var
  id : Longint	;
  szSrcPDFFile : PChar ;
  szDesPDFFile : PChar ;
  szRange : PChar ;

begin
  if( LoadapWDll() = True ) then
  begin

    szSrcPDFFile:='example.pdf';
    szDesPDFFile:='example';
    szRange:='2,4;1,3-4;2-3';

    id:=fnOpenSplit(szSrcPDFFile);
    if(id>0) then begin
      fnAddInfo(id,'Title','Subject','Author','Keywords','Creator');
      fnSetFunction(id,ap_Set_Log,0,0,'log.log',nil);

      fnSetFunction(id,ap_Set_Split,1,2,szRange,szDesPDFFile);

      fnClose(id);
    end;


    szSrcPDFFile:='example.pdf';
    szDesPDFFile:='example_merge.pdf';

    id:=fnCreateMerge(szDesPDFFile);
    if(id>0) then begin
      fnAddInfo(id,'Title','Subject','Author','Keywords','Creator');
      fnSetFunction(id,ap_Set_Log,0,0,'log.log',nil);

      fnSetFunction(id,ap_Set_Merge,0,0,szSrcPDFFile,nil);
      fnSetFunction(id,ap_Set_Merge,0,0,szSrcPDFFile,nil);

      fnClose(id);
    end;

  end;
  FreeapWDll();

end;
//****************************************************************************



end.
